#include <stdio.h>
#include <fcntl.h>

#include <asm/types.h>   /* headers for architecture specific data types                         */
#include <unistd.h>      /* contains the prototype for i386 specific ioperm functioni            */
#include <asm/io.h>      /* obviously architecture specific (asm directory) for inb, outb macros */
#include <string.h>

#define LP_BASE 0x240

int banner[50];
int fd, colnum = 0;

void readbanner(char *filename) {
  char line[20];
  int column,i;
  FILE *fonts = fopen(filename,"r");
  while (fgets(line, 20, fonts) != NULL) {
    column = 0;
    for (i = 0; i < strlen(line); i++) {
      if (line[i] == '+') {
	column |= (int)(1 << i);
      }
    }
    banner[colnum] = column;
    colnum++;
  }
  fclose(fonts);
}

int main(int argc, char** argv) {

	int i,j;
	int index = 0;
        int dir = 1;
	fd = open("/dev/ibus0",O_RDWR);

	if (argc == 2) {
	  readbanner(argv[1]);
	} else {
	  printf("No banner file. \n");
	  exit(1);
	}

	while (1) {
	  if (index == colnum || index < 0) {
	    dir = (dir == 1? -1 : 1);
	    index += dir;
	  }
	  write(fd,&banner[index],2);
	  index += dir;
	}
        
	return(0);  /* just to be nice ;) */

}
